<!--
title: Logging with Loki
description: 
published: true
date: 2022-01-19T15:12:58.329Z
tags: 
editor: ckeditor
dateCreated: 2021-12-21T14:01:41.103Z
-->

<h1>Logging with Loki&nbsp;</h1>
<p>For logging in our Kubernetes we use the Grafana Loki stack, this includes Loki as logging backend, promtail for the logging agent/collector and Grafana as frontend.</p>
<p>Loki is described as “Like Prometheus, but for logs“, in the sense that it uses Kubernetes labels in the same way as Prometheus does. Loki aims for cost effectiveness and easy operation.</p>
<h1>Installation</h1>
<p>We use the following Helm installation, but is managed by ArgoCD:</p>
<pre><code class="language-plaintext">helm upgrade --install loki grafana/loki-stack --namespace=logging --set promtail.enabled=true,loki.persistence.enabled=true,loki.per
sistence.storageClassName=longhorn,loki.persistence.size=5Gi</code></pre>
<p>The Loki data source can now be added in Grafana with the following URL or can be done automatically with a ConfigMap for Grafana: <a href="http://loki.logging.svc.cluster.local:3100">http://loki.logging.svc.cluster.local:3100</a></p>
<p>See it already live at: <a href="https://grafana.dev-jointcyberrange.nl/">https://grafana.dev-jointcyberrange.nl/</a></p>
<h1>Usage</h1>
<h2>Grafana</h2>
<p>Click on <code>Explore</code> in the menu on the left:</p>
<figure class="image"><img src="/Development/Monitoring-&-Logging/Assets/explore.png"></figure>
<p>&nbsp;</p>
<p>Select <code>Loki</code> as data source to exlore in the top left corner:</p>
<figure class="image"><img src="/Development/Monitoring-&-Logging/Assets//select-loki.png"></figure>
<p>Click on the <code>Log browser</code> button:</p>
<figure class="image"><img src="/Development/Monitoring-&-Logging/Assets/log-browser.png"></figure>
<p>Select the desired Kubernets labels to extract logs from:</p>
<figure class="image"><img src="/Development/Monitoring-&-Logging/Assets/kubernetes-label.png"></figure>
<p>Click on the <code>Show logs</code> button:</p>
<figure class="image"><img src="/Development/Monitoring-&-Logging/Assets/show-logs.png"></figure>
<p>Your logs will now appear:</p>
<figure class="image"><img src="/Development/Monitoring-&-Logging/Assets/logs.png"></figure>
<h2>LogCLI</h2>
<p>The LogCLI is an alternative interface that can interact with the Loki API. To access Loki with the LogCLI, Loki will have to be exposed. Loki doesn’t support a native authentication method and has to be implemeted in combination with a reverse proxy or other technique. For this we use the NGINX Ingress Controller and enabled HTTP Basic Authentication.</p>
<p>Install the LogCLI by following the documentation at: <a href="https://grafana.com/docs/loki/latest/getting-started/logcli/">https://grafana.com/docs/loki/latest/getting-started/logcli/</a></p>
<p>The LogCLI can be used as followed:</p>
<pre><code class="language-plaintext">export LOKI_ADDR=https://loki.dev-jointcyberrange.nl
export LOKI_USERNAME=loki-username
export LOKI_PASSWORD=loki-passowrd
logcli --tls-skip-verify query '{app_kubernetes_io_name="ingress-nginx"}'</code></pre>
